/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package workingwithstreamsproject;

import java.util.ArrayList;
import java.util.List;
import java.util.function.BinaryOperator;
import java.util.function.Predicate;
import java.util.stream.Stream;

/**
 *
 * @author aboudiab
 */
public class WorkingWithStreams {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Stream<String> stream1 = Stream.of(
                "This is a test",
                "Programming is fun",
                "Java 8 new features are interesting",
                "Four",
                "Java programming");
        Predicate<String> p = Predicate.isEqual("Four");
        Stream<String> stream2 = stream1.filter(p);
        stream2.forEach(s -> System.out.println(s));
        
        System.out.println("---------------DONE-------");
        
        List<Integer> result = new ArrayList<>();
        Stream<Integer> ages = Stream.of(32,23,14,16,45,67,42,66,53,5);
        Predicate<Integer> p1 = x -> x%2 == 0;
        Predicate<Integer> p2 = x2 -> x2 > 45;
        ages.peek(System.out::println)
            .filter(p1.and(p2))
            .forEach(result::add);
        System.out.println("list size = " + result.size());
        System.out.println("---------------DONE-------");
        
        Stream<Integer> grades = Stream.of(78,90,88,74,94,92,83);
        BinaryOperator<Integer> sum = (x1,x2) -> x1+x2;
        int value = grades.reduce(0, sum);
        System.out.println("Sum = " + value);
    }
    
}
